﻿using System;
using System.Web;

namespace AsyncFactoryWEB
{
    public class AspxAsyncResult:IAsyncResult
    {
        public AspxAsyncResult(HttpContext context,IHttpHandler handler,AsyncCallback callBack)
        {
            this.context = context;
            this.handler = handler;
            this.callBack = callBack;
        }

        private HttpContext context;
        private IHttpHandler handler;
        private AsyncCallback callBack;
        private bool isCompleted = false;

        public void Execute()
        {
            try
            {
                handler.ProcessRequest(context);
            }
            catch { }
            finally
            {
                try
                {
                    if (callBack != null)
                        callBack(this);
                }
                catch { }
                isCompleted = true; 
            }
        }

        public object AsyncState
        {
            get { return null; }
        }

        public System.Threading.WaitHandle AsyncWaitHandle
        {
            get { return null; }
        }

        public bool CompletedSynchronously
        {
            get { return false; }
        }

        public bool IsCompleted
        {
            get { return isCompleted; }
        }

    }
}
