﻿using System.Collections.Generic;
using System.Threading;

namespace AsyncFactoryWEB
{
    public class TaskQueue
    {
        public TaskQueue(int workerCount)
        {
            workers = new List<Worker>(workerCount);
            for (int i = 0; i < workerCount; i++)
            {
                workers.Add(new Worker());
            }
        }

        public IList<Worker> workers;
        public long index = 0;

        private int GetIndex()
        {
            return (int)Interlocked.Increment(ref index) % workers.Count;
        }

        public void Add(AspxAsyncResult result)
        {
            if(result!=null)
            {
                int workerIndex = GetIndex();
                workers[workerIndex].Push(result);
            }
        }
    }
}
