﻿using System.Collections.Generic;
using System.Threading;

namespace AsyncFactoryWEB
{
    public class Worker
    {
        public Worker()
        {
            ThreadPool.QueueUserWorkItem(OnRun);
        }

        private Queue<AspxAsyncResult> queueItems = new Queue<AspxAsyncResult>(1024);

        public void Push(AspxAsyncResult result)
        {
            lock (this)
                queueItems.Enqueue(result);
        }

        public AspxAsyncResult Pop()
        {
            lock (this)
            {
                if (queueItems.Count > 0)
                    return queueItems.Dequeue();
                return null;
            }
        }

        public void OnRun(object obj)
        {
            while (true)
            {
                AspxAsyncResult asyncResult = Pop();
                if (asyncResult != null)
                {
                    asyncResult.Execute();
                }
                else
                    Thread.Sleep(10);
            }
        }
    }
}
