﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Threading;

namespace HttpContextReleated
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                // The HttpContext associated with the page can be accessed by the Context property.
                System.Text.StringBuilder sb = new System.Text.StringBuilder();
                // Use the current HttpContext object to determine if custom errors are enabled.
                sb.Append("Is custom errors enabled: " +
                    Context.IsCustomErrorEnabled.ToString() + "<br/>");

                // Use the current HttpContext object to determine if debugging is enabled.
                sb.Append("Is debugging enabled: " +
                    Context.IsDebuggingEnabled.ToString() + "<br/>");

                // Use the current HttpContext object to access the current TraceContext object.
                sb.Append("Trace Enabled: " +
                    Context.Trace.IsEnabled.ToString() + "<br/>");

                // Use the current HttpContext object to access the current HttpApplicationState object.
                sb.Append("Number of items in Application state: " +
                    Context.Application.Count.ToString() + "<br/>");

                // Use the current HttpContext object to access the current HttpSessionState object.
                // Session state may not be configured.
                try
                {
                    sb.Append("Number of items in Session state: " +
                        Context.Session.Count.ToString() + "<br/>");
                }
                catch
                {
                    sb.Append("Session state not enabled. <br/>");
                }

                // Use the current HttpContext object to access the current Cache object.
                sb.Append("Number of items in the cache: " +
                    Context.Cache.Count.ToString() + "<br/>");

                // Use the current HttpContext object to determine the timestamp for the current HTTP Request.
                sb.Append("Timestamp for the HTTP request: " +
                    Context.Timestamp.ToString() + "<br/>");

                // Assign StringBuilder object to output label.
                Response.Write(sb.ToString());


                Response.Write(string.Format("current ThreadID:{0}, current HttpContent content:{1}", Thread.CurrentThread.ManagedThreadId.ToString(), httpContext.Cache["t"].ToString()));
                Response.Write("\r\n");

                BeginWork();

            }
        }

        /**
         * 注意,由于HttpContext是处于当前主线程中,所以利用异步方法的时候,在异步方法内部,是无法获取到HttpContext的实例对象的
         * 这就需要缓存当前的HttpContext对象,然后传入异步方法内部才行.
         * **/

        private void BeginWork()
        {
            Action action = new Action(Work);
            action.BeginInvoke(new AsyncCallback((iar) =>
            {
                Action actionEnd = (Action)iar.AsyncState;
                actionEnd.EndInvoke(iar);
            }),action);
        }

        HttpContext httpContext = HttpContext.Current;

        private void Work()
        {
            if (null!=HttpContext.Current)
                Response.Write(string.Format("current ThreadID:{0},　current HttpContent content:{1}", Thread.CurrentThread.ManagedThreadId.ToString(), httpContext.Cache["t"].ToString()));
           // else
           //     httpContext.Response.Write(string.Format("current ThreadID:{0},　current HttpContent content:{1}", Thread.CurrentThread.ManagedThreadId.ToString(), httpContext.Cache["t"].ToString()));

        }
    }
}
