﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Threading;
using System.Net;
using System.IO;

namespace SocketClient
{
    class Program
    {
        static void Main(string[] args)
        {
            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPEndPoint ipEndPoint = new IPEndPoint(IPAddress.Parse("127.0.0.1"), 4096);

            SocketAsyncEventArgs connectArgs = new SocketAsyncEventArgs();

            connectArgs.UserToken = socket;
            connectArgs.RemoteEndPoint = ipEndPoint;
            connectArgs.Completed += OnConnected;

            socket.ConnectAsync(connectArgs);

            

            Console.ReadLine();
        }

        private static void OnSend(object sender, SocketAsyncEventArgs e)
        {
            Console.WriteLine("SendOk: {0}", e.UserToken.ToString());
        }

        private static void OnConnected(object sender, SocketAsyncEventArgs e)
        {
            if (e.SocketError == SocketError.Success)
            {
                Console.WriteLine("Conectioned");

                Socket socket = e.UserToken as Socket;
                socket.SendBufferSize = Int16.MaxValue;

                byte[] initBuffer = new byte[200];

                string tmp = string.Empty;
                string textLength = "[totallength=120]";
                string content = "Hello Server.";
                string text = "[length=" + content.Length + "]" + content;

                for (int i = 0; i < 5; i++)
                {
                    tmp += text;
                }
                textLength = textLength + tmp;

                byte[] sendBytes = Encoding.ASCII.GetBytes(textLength);

                Buffer.BlockCopy(sendBytes, 0, initBuffer, 0, sendBytes.Length);

                SocketAsyncEventArgs sendArgs = new SocketAsyncEventArgs();
                sendArgs.SetBuffer(initBuffer, 0, sendBytes.Length);

                sendArgs.UserToken = socket;
                socket.SendAsync(sendArgs);

                SocketAsyncEventArgs recvArgs = new SocketAsyncEventArgs();
                recvArgs.SetBuffer(initBuffer, 0, sendBytes.Length);
                recvArgs.Completed += OnReceiveCompleted;
                recvArgs.AcceptSocket = socket;

                if (!recvArgs.AcceptSocket.ReceiveAsync(recvArgs))
                {
                    ProcessReceive(recvArgs);
                }
            }
            else
            {
                Console.WriteLine("Error encountered.");
            }
        }

        private static void ProcessReceive(SocketAsyncEventArgs e)
        {
            if (e.BytesTransferred > 0)
            {
                if (e.SocketError == SocketError.Success)
                {
                    Console.WriteLine(Encoding.ASCII.GetString(e.Buffer,e.Offset,e.BytesTransferred));
                }
            }
        }

        private static void OnReceiveCompleted(object sender, SocketAsyncEventArgs e)
        {
            switch (e.LastOperation)
            {
                case SocketAsyncOperation.Receive:
                    ProcessReceive(e);
                    break;
                default: break;
            }
        }
    }
}
