﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Net;

namespace SocketLBR
{
    public class SocketServer
    {
        Socket server;

        public SocketServer(IPEndPoint localPoint)
        {
            server = new Socket(localPoint.AddressFamily, SocketType.Stream, ProtocolType.Tcp);
            server.Bind(localPoint);
            server.Listen(5);

            AcceptAsyncConnections();
        }

        private void AcceptAsyncConnections()
        {
            SocketAsyncEventArgs acceptSock = new SocketAsyncEventArgs();
            acceptSock.Completed += AcceptCompleted;
            server.AcceptAsync(acceptSock);
        }

        private void AcceptCompleted(object sender, SocketAsyncEventArgs e)
        {
            AcceptAsyncConnections();

            Socket client = e.AcceptSocket;
            e.Completed -= AcceptCompleted;
            e.Completed += ReceiveCompleted;

            byte[] buffer = new byte[1024];
            e.SetBuffer(buffer, 0, buffer.Length);

            client.ReceiveAsync(e);
        }

        private void ReceiveCompleted(object sender, SocketAsyncEventArgs e)
        {
            Socket client = sender as Socket;
            if (e.BytesTransferred == 0)
            {
                Console.WriteLine("Socket is closed.");
                client.Close();
            }
            else
            {
                Console.WriteLine(String.Format("Received:{0}", Encoding.ASCII.GetString(e.Buffer)));
                client.Send(e.Buffer, e.BytesTransferred, SocketFlags.None);
                client.ReceiveAsync(e);
            }
        }
    }
}
