﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;

namespace SocketServer
{
    internal sealed class SocketAsyncEventArgsPool
    {
        Stack<SocketAsyncEventArgs> pool;

        internal SocketAsyncEventArgsPool(int capacity)
        {
            this.pool = new Stack<SocketAsyncEventArgs>(capacity);
        }

        internal int Count
        {
            get { return this.pool.Count; }
        }

        internal SocketAsyncEventArgs Pop()
        {
            lock (this.pool)
            {
                return this.pool.Pop();
            }
        }

        internal void Push(SocketAsyncEventArgs item)
        {
            if (item == null)
                throw new Exception("Object is not set.");
            lock (this.pool)
            {
                this.pool.Push(item);
            }
        }
    }
}
